#include "Event/dataIOROOTServer.h"
#include "Event/IOfileNull.h"
#include "Event/rTreeBase.cpp"

//-------- public ---------------

// acess
rTreeInServer*    dataIOROOTServer::treeIn()  const {return m_TreeIn;}
rTreeOutServer*   dataIOROOTServer::treeOut() const {return m_TreeOut;}
rHistoOutServer*  dataIOROOTServer::histo()   const {return m_Histo;}

//###############################
dataIOROOTServer::dataIOROOTServer()
//###############################
{
	m_TreeIn   = new rTreeInServer();
	m_TreeOut  = new rTreeOutServer();
	m_Histo    = new rHistoOutServer();

	defineIOfiles();
}

//###############################
void dataIOROOTServer::defineIOfiles()
//###############################
{
	addIOfile("input", m_TreeIn);
	addIOfile("output",m_TreeOut);
	addIOfile("histo", m_Histo);
}
//###############################
dataIOROOTServer::~dataIOROOTServer()
//###############################
{
	delete m_TreeIn;
	delete m_TreeOut;
	delete m_Histo;
}
