#include "Event/eventProcess.h"
#include "Event/processManager.h"
#include "Event/messageManager.h"

//###############################
eventProcess::eventProcess(std::string name)
//###############################
{
	m_genName = "";
	m_recName = "";
	m_anaName = "";

	m_eventProcessName = "";

	setName(name);
}
//###############################
void eventProcess::setOption(std::string task, std::string algorithm)
//###############################
{
	optionVI::setOption(task,algorithm);
	if (task == "addEventProcess") {
		/*! add and eventVI into the eventComposite of this eventProcess */
		eventProcess* evtP = processManager::instance()->getEventProcess(algorithm);
		if (evtP ==0) return;
		add(algorithm,evtP);
		message(" eventProcess "+algorithm+" added into eventProcess "+name(),"RELEASE");
	} else if (task == "generation" || task == "reconstruction" || task == "analysis") {
		/*! add and algorithmVI into the algorithmComposite of the main eventVI of this
		eventComposite */
		algorithmVI* alg = processManager::instance()->getAlgorithm(algorithm);
		if (alg == 0) return;
		if (task == "generation") genAlg()->add(algorithm,alg);
		else if (task == "reconstruction") recAlg()->add(algorithm,alg);
		else if (task == "analysis") anaAlg()->add(algorithm,alg);
		message(" algorithm "+algorithm+" added into "+task+" of the eventProcess "+name(),"RELEASE");
	}
}
//###############################
void eventProcess::defineOption()
//###############################
{
	//! note: the optionVI allways needs a pointer
	//! this options are going to be overwriten to take an action (operation)
	optionVI::defineOption("generation",&m_genName);
	optionVI::defineOption("reconstruction",&m_recName);
	optionVI::defineOption("analysis",&m_anaName);

	optionVI::defineOption("addEventProcess",&m_eventProcessName);
}
//###############################
void eventProcess::writeOut() const
//###############################
{
	if (!acceptLevel()) return;
	std::ostream& out = messageManager::instance()->out();
	messageVI::writeOut();

	if (eventComposite::size() > 0 ) {
		out << " >> eventProcess in Server << " << "\n";
		out << nameList();
	}
	if (genAlg()->size() >0 ) {
		out << " -- algorithms in generation of : " << name() << " -- " << "\n";
		out << genAlg()->nameList();
	}
	if (recAlg()->size() > 0 ) {
		out << " -- algorithms in reconstruction of : "<< name() <<" -- " << "\n";
		out << recAlg()->nameList();
	}
	if (anaAlg()->size() > 0 ) {
		out << " ** algorithms in analysis of : " <<name() <<" ** " << "\n";
		out << anaAlg()->nameList();
	}
}
