#include "Event/eventTask.h"
#include "Event/processManager.h"
#include "Event/messageManager.h"

//###############################
eventTask::eventTask(std::string name)
//###############################
{
	m_genName = "";
	m_recName = "";
	m_anaName = "";

	m_eventTaskName = "";

	setName(name);
}
//###############################
void eventTask::setOption(std::string task, std::string algorithm)
//###############################
{
	optionVI::setOption(task,algorithm);
	if (task == "addEventTask") {
		/*! add and eventVI into the eventComposite of this eventTask */
		eventTask* evtP = processManager::instance()->getEventTask(algorithm);
		if (evtP ==0) return;
		add(algorithm,evtP);
		message(" eventTask "+algorithm+" added into eventTask "+name(),"RELEASE");
	} else if (task == "generation" || task == "reconstruction" || task == "analysis") {
		/*! add and algorithmVI into the algorithmComposite of the main eventVI of this
		eventComposite */
		algorithmVI* alg = processManager::instance()->getAlgorithm(algorithm);
		if (alg == 0) return;
		if (task == "generation") genAlg()->add(algorithm,alg);
		else if (task == "reconstruction") recAlg()->add(algorithm,alg);
		else if (task == "analysis") anaAlg()->add(algorithm,alg);
		message(" algorithm "+algorithm+" added into "+task+" of the eventTask "+name(),"RELEASE");
	}
}
//###############################
void eventTask::defineOption()
//###############################
{
	//! note: the optionVI allways needs a pointer
	//! this options are going to be overwriten to take an action (operation)
	optionVI::defineOption("generation",&m_genName);
	optionVI::defineOption("reconstruction",&m_recName);
	optionVI::defineOption("analysis",&m_anaName);

	optionVI::defineOption("addEventTask",&m_eventTaskName);
}
//###############################
void eventTask::writeOut() const
//###############################
{
	if (!acceptLevel()) return;
	std::ostream& out = messageManager::instance()->out();
	messageVI::writeOut();

	if (eventComposite::size() > 0 ) {
		out << " -- eventTask in Server of : " << name()  << " -- " << "\n";
		out << nameList();
	}
	if (genAlg()->size() >0 ) {
		out << " -- algorithms in generation of : " << name() << " -- " << "\n";
		out << genAlg()->nameList();
	}
	if (recAlg()->size() > 0 ) {
		out << " -- algorithms in reconstruction of : "<< name() <<" -- " << "\n";
		out << recAlg()->nameList();
	}
	if (anaAlg()->size() > 0 ) {
		out << " -- algorithms in analysis of : " <<name() <<" -- " << "\n";
		out << anaAlg()->nameList();
	}
}
