#include "Event/optionServer.h"
#include "Event/messageManager.h"

//############################################
optionServer::optionServer()
//############################################
{
	m_optionFileName = "";
	m_server = new serverVI<optionVI>();
}
//############################################
optionServer::~optionServer()
//############################################
{
	delete m_server;
}
//########################################
void optionServer::setOption()
//########################################
{

	std::string name = m_optionFileName;
	if (name == "") return;
	messageManager::instance()->message(" Using option file "+name);
	std::ifstream file(name.c_str());
	if (!file) {
		messageManager::instance()->message(" Could not open init file "+ name);
		file.close();
		return;
	}

	std::string comment = "";
	std::string className ="";
	std::string parName="";
	std::string parType="S";
	std::string parString="";
	double parDouble = 0.;
	int parInteger = 0;

	// read-in option file
	while(!file.eof()) {
		file >> className;		
		if (className == "//") std::getline(file,comment);
		else {
			file >> parName;
			file >> parType;
			if (parType == "S") {
				file >> parString;
				setOption(className, parName, parString);
			} else if (parType == "D") {
				file >> parDouble;
				setOption(className, parName,parDouble);
			} else if (parType == "I") {
				file >> parInteger;
				setOption(className, parName,parInteger);
			} 
		}
		className = "";
		parName   = "";
		parType   = "";
		parString = "";
		parDouble = 0.;
		parInteger = 0;
	} // end of file

	// close option file
	file.close();	
}
//########################################
void optionServer::setOption(std::string Oname, std::string par, std::string con)
//########################################
{
	optionVI* op = getOption(Oname);
	if (!op) return;
	if (!op->search(par)) {
		messageManager::instance()->message(" not a string option named ",par);
		return;
	}
	op->setOption(par,con);
	messageManager::instance()->message(" option applied "+Oname+"->"+par+" = "+con);
}
//########################################
void optionServer::setOption(std::string Oname, std::string par, double con)
//########################################
{
	optionVI* op = getOption(Oname);
	if (!op) return;
	if (!op->search(par)) {
		messageManager::instance()->message(" not a double option named ",par);
		return;
	}
	op->setOption(par,con);
	messageManager::instance()->message(" option applied "+Oname+" -> "+par+" = ",con);
}
//########################################
void optionServer::setOption(std::string Oname, std::string par, int con)
//########################################
{
	optionVI* op = getOption(Oname);
	if (!op) return;
	if (!op->search(par)) {
		messageManager::instance()->message(" not an integer option named ",par);
		return;
	}
	op->setOption(par,con);
	messageManager::instance()->message(" option applied "+Oname+" -> "+par+" = ",con);
}
//########################################
optionVI* optionServer::getOption(std::string Oname) const
//########################################
{
	if (m_server->search(Oname)) return m_server->get(Oname);
	else return 0;
}
//########################################
void optionServer::addToServer(std::string name, optionVI* op)
//########################################
{
	if (!m_server->search(name)) m_server->add(name,op);
	else messageManager::instance()->
		message(" class already in option server "+name);

}
//########################################
void optionServer::writeOutOptionsServer() const
//########################################
{
	std::ostream& out = messageManager::instance()->out();
	out << " ** information about options ** " <<"\n";
	for (int i=0; i < m_server->size(); i++) m_server->get(i)->writeOutOptions();
}
//########################################
void optionServer::writeOut() const
//########################################
{
	std::ostream& out = messageManager::instance()->out();
	if (m_server->size() == 0) return;
	out << " -- info of option server -- " << "\n";
	out << " option File name = " << m_optionFileName;
	out << " >> objecs in optionSever << " << "\n";
	out << m_server->nameList();
	if (!messageManager::instance()->acceptLevel("DEBUG")) return;
	for (int i = 0 ; i < m_server->size(); i++) 
		m_server->get(i)->writeOutOptions();
}
