
#include "Event/runEventAlg.h"

#include "Event/selectionManager.h"
#include "Event/processManager.h"

//###################################
void runEventAlg::execute()
//###################################
{
	if (!defined()) define();

	//! should we read the next event
	if (m_cReadEvent->apply()) {
		//! read the event
		m_aReadEvent->run();
		//! process the event
		m_aProcessEvent->run();
		//! should we write this event, if yes, write it
		if (m_cWriteEvent->apply()) m_aWriteEvent->run();
	} else {
		m_aSkipEvent->run();
	}
}
//###################################
void runEventAlg::define()
//###################################
{
	//! this method is only executed one at run time
	setDefine(true);

	//! retrieve the algorithms and conditions needed
	m_cReadEvent  = selectionManager::instance()->getCut("selRead"); 
	m_cWriteEvent = selectionManager::instance()->getCut("selWrite");
	

	m_aReadEvent    = processManager::instance()->getAlgorithm("comReadEvent");
	m_aSkipEvent    = processManager::instance()->getAlgorithm("comSkipEvent");
	m_aWriteEvent   = processManager::instance()->getAlgorithm("comWriteEvent");
	m_aProcessEvent = processManager::instance()->getAlgorithm("runEvent");

}